*SAS program 3.2-2;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME lib 'd:\MLM\data';

Data Data1;
Set lib.ML_data_Chap3;

*Empty model;
PROC MIXED METHOD=REML noclprint COVTEST; 
CLASS site; 
MODEL inject=/SOLUTION;
RANDOM INT /SUBJECT=site SOLUTION; 
ODS output solutionr=Ran_effect; 
Run;

Data Data2 (keep=site u0j);
 Set Ran_effect;
Rename Estimate=u0j;

*estimate group means;
Proc SQL;
  Create Table Data3 as select site, mean(inject) as y_bar_j,
  count(site) as n_j from data1
  Group by site;
Quit;

Data Data4;
Merge Data2(in=d1) data3(in=d2);
By site;
y_bar=64.0377; *estimated sample overall mean;
grand_mean=61.4366; *empty model BLUP estimate of grand mean;
Var_U0j=523.57; *empty model estimated variance of level-2 residuals u0j;
Var_eij=4350.47; *empty model estimated variance of level-1 residuals eij;
BLUP_Beta0j=u0j+grand_mean;
Rho_0j=Var_U0j/(Var_U0j+(Var_eij/n_j));
EB_Beta0j=Rho_0j*y_bar_j+(1-Rho_0j)*y_bar;

Proc print Data=Data4 noobs;
Var site n_j grand_mean y_bar_j u0j Rho_0j BLUP_Beta0j EB_Beta0j;
Run;
