*SAS Program 4.7.3-3;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME lib 'd:\MLM\data';

Data data1;
  Set Lib.ML_Chap4_data;

C_QOL=QOL;
if Time = 0 and QOL > 5 then C_QOL= 5;
If Time =0 then do;
  Time1=0;
  Time2=0;
End;
Else if Time in (1,2,3,4,5,6) then do;
  Time1=1;
  Time2=Time-1;
End;

Proc Format;
Value group 0='Control' 1='Treatment';
Run;

Proc Mixed covtest noclprint noitprint IC;
Class ID;
Model C_QOL=Trt|Time Trt|Time2 
   /S DDFM=KR OUTPM=Pred_out2(keep=ID Time Time1 Time2 Trt C_QOL Pred);
Random Int Time Time2/subject=ID type=UN; 
Format Trt group.;
Run;

Proc Means Data=Pred_out2 noprint nway;  
Var C_QOL  Pred;
Class Trt Time;
Output OUT=predmean mean=C_QOL_M  Predm;
Run;

Proc Print Data=predmean (drop= _type_ _freq_); 
Format _numeric_ f4.2; *clearing format of numerical variables and reformat them;
Run;

Data Pdata; 
 Set Predmean;
group_ob=Trt; group_pr=Trt; 
Proc Format;
Value group_ob 0='Control_Obsv' 1='Trt_Obsv';
Value group_pr 0='Control_Pred' 1='Trt_Pred';
Proc GPLOT data=Pdata;
Format group_ob group_ob.; 
format group_pr group_pr.;
Label group_pr='Treatment_pred'; label group_ob='Treatment_obsv'; 
Label C_QOL_M='Observed';
Symbol1 c=blue i=j l=2;  
Symbol2 c=red i=j l=1;
Symbol3 c=blue i=none v=circle;
Symbol4 c=red i=none v=dot;
Plot predm*time=group_pr / haxis=0 to 6 by 1 vaxis=3.4 to 5 by .2;
Plot2 C_QOL_M*Time=group_ob /vaxis=3.4 to 5 by .2;
Title '  ';
Title2 'Piecewise linear growth model';
Run; 
Quit;

