*SAS Program 5.4.2-2;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'd:\MLM\data';

Data data1;
 Set Lib.ML_data_Chap5;

Reg_Eth=HIV_Region*ethnic;
PROC NLMIXED;
PARMS B1HIV_Region=0.9 B2ethnic=-0.6 B3Reg_Eth=0.4 B4gender=-0.1
B5gdmc_age=0.02 B6highsch=0.04 V_u0=0.70 V_u1=0.32;
Bounds b>0;
eta=B1HIV_Region*HIV_Region+B2ethnic*ethnic+B3Reg_Eth*Reg_Eth
+B4gender*gender+B5gdmc_age*gdmc_age+B6highsch*highsch+u0 + u1*ethnic;
IF (inject_c=1) THEN P=1/(1+EXP(-(a+eta)));
ELSE IF (inject_c=2) THEN P=(1/(1+EXP(-(a+b+eta))))-(1/(1+EXP(-(a+eta))));
ELSE IF (inject_c=3) THEN P=1-(1/(1+EXP(-(a+b+eta))));
if (P>1e-8) then LL=log(P); else LL=-1e20;
MODEL inject_c ~ GENERAL(LL);
RANDOM u0 u1 ~ NORMAL([0,0], [V_u0,0,V_u1]) SUBJECT=SITE;
ESTIMATE 'Intercept2' a+b;
Run;
