*SAS Program 5.5.3-2;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'd:\MLM\data';

Data data1;
 Set Lib.ML_data_Chap5;
Reg_Eth=HIV_Region*ethnic;
PROC NLMIXED; 
PARMS 
GA0=-0.90 GA1HIV_Region=1.40 GA2ethnic=-0.75 GA3Reg_Eth=0.32
GA4gender=-0.16 GA5gdmc_age=0.02 GA6highsch=0.05 V_u0a=0.81 V_u1a=0.18
GB0=-0.08 GB1HIV_Region=0.96 GB2ethnic=-0.69 GB3Reg_Eth=0.10
GB4gender=0.01 GB5gdmc_age=0.02 GB6highsch=0.05 V_u0b=0.40 V_u1b=0.08; 
eta1=GA0+GA1HIV_Region*HIV_Region+GA2ethnic*ethnic
     +GA3Reg_Eth*Reg_Eth+GA4gender*gender+GA5gdmc_age*gdmc_age
     +GA6highsch*highsch+(u0a+u1a*ethnic);
eta2=GB0+GB1HIV_Region*HIV_Region+GB2ethnic*ethnic
     +GB3Reg_Eth*Reg_Eth+GB4gender*gender+GB5gdmc_age*gdmc_age
     +GB6highsch*highsch+(u0b+u1b*ethnic); 
IF (inject_c=3) THEN P=1/(1+EXP(eta1)+EXP(eta2));  
ELSE IF (inject_c=1) THEN P=EXP(eta1)/(1+EXP(eta1)+EXP(eta2));
ELSE IF (inject_c=2) THEN P=EXP(eta2)/(1+EXP(eta1)+EXP(eta2));
LL = LOG(P);
MODEL Inject_c ~ GENERAL(LL);
RANDOM u0a u1a u0b u1b ~ NORMAL([0,0,0,0], [V_u0a,0,V_u1a,0,0,V_u0b,0,0,0,V_u1b])  SUBJECT=site;
Run;
