*SAS Program 5.6.4-4;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'd:\MLM\data';

Data data1;
  Set Lib.ML_data_Chap5;
PROC SQL;
Create table Temp as select site, heavy_inj, 
 100*(mean(heavy_inj)) as m_heavy_inj from Data1
Group by Site;
Create table Data2 as select distinct site, m_heavy_inj, 
 m_heavy_inj>15 as Hinj_Region from Temp;
Quit;

Data Data3;
Merge data1 Data2; by site;

PROC GLIMMIX noitprint noclprint; 
Class site; 
MODEL jailyear=Hinj_Region|gender ethnic gdmc_age highsch
  /S DIST=NB LINK=LOG DDFM=BW;
RANDOM Int gender/subject=site type=Chol; 
NLOPTIONS TECH=NRRIDG;
Run;
