*SAS Program 5.6.4-6;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'D:\MLM\data';

Data data1;
  Set Lib.ML_data_Chap5;

PROC SQL;
Create table temp as select site, heavy_inj, 
 100*(mean(heavy_inj)) as m_heavy_inj from data1
Group by site;
Create table data2 as select distinct site, m_heavy_inj, 
 m_heavy_inj>15 as Hinj_Region from temp;
Quit;

Data data3;
Merge data1 data2; by site;

Hinj_gender=Hinj_Region*gender;
PROC NLMIXED;
PARMS B0=.03 B_Hinj_Region=0.46 B_gender=1.08 B_Hinj_gender=-.21 B_ethnic=.22
      B_gdmc_age=.05 B_highsch=-0.03 V_u0=.36 V_u1=.14 Cov_u01=0;
eta=B0+B_Hinj_Region*Hinj_Region+B_gender*gender+B_Hinj_gender*Hinj_gender+
     B_ethnic*ethnic+B_gdmc_age*gdmc_age+B_highsch*highsch+u0+u1*gender; 
lambda=exp(eta);
MODEL jailyear ~ POISSON(lambda);
RANDOM u0 u1 ~ NORMAL([0,0], [V_u0,Cov_u01,V_u1]) SUBJECT=SITE;
RUN;
